<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_InternalSupplier ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_InternalSupplier extends AbstractStructArrayBase
{
    /**
     * The InternalServiceSupplier
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_InternalSupplier[]
     */
    public $InternalServiceSupplier;
    /**
     * Constructor method for ArrayOfJP_InternalSupplier
     * @uses ArrayOfJP_InternalSupplier::setInternalServiceSupplier()
     * @param \StructType\JP_InternalSupplier[] $internalServiceSupplier
     */
    public function __construct(array $internalServiceSupplier = array())
    {
        $this
            ->setInternalServiceSupplier($internalServiceSupplier);
    }
    /**
     * Get InternalServiceSupplier value
     * @return \StructType\JP_InternalSupplier[]|null
     */
    public function getInternalServiceSupplier()
    {
        return $this->InternalServiceSupplier;
    }
    /**
     * Set InternalServiceSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier[] $internalServiceSupplier
     * @return \ArrayType\ArrayOfJP_InternalSupplier
     */
    public function setInternalServiceSupplier(array $internalServiceSupplier = array())
    {
        foreach ($internalServiceSupplier as $arrayOfJP_InternalSupplierInternalServiceSupplierItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_InternalSupplierInternalServiceSupplierItem instanceof \StructType\JP_InternalSupplier) {
                throw new \InvalidArgumentException(sprintf('The InternalServiceSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($arrayOfJP_InternalSupplierInternalServiceSupplierItem) ? get_class($arrayOfJP_InternalSupplierInternalServiceSupplierItem) : gettype($arrayOfJP_InternalSupplierInternalServiceSupplierItem)), __LINE__);
            }
        }
        $this->InternalServiceSupplier = $internalServiceSupplier;
        return $this;
    }
    /**
     * Add item to InternalServiceSupplier value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_InternalSupplier $item
     * @return \ArrayType\ArrayOfJP_InternalSupplier
     */
    public function addToInternalServiceSupplier(\StructType\JP_InternalSupplier $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_InternalSupplier) {
            throw new \InvalidArgumentException(sprintf('The InternalServiceSupplier property can only contain items of \StructType\JP_InternalSupplier, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->InternalServiceSupplier[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_InternalSupplier|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_InternalSupplier|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_InternalSupplier|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string InternalServiceSupplier
     */
    public function getAttributeName()
    {
        return 'InternalServiceSupplier';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_InternalSupplier
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
